# coding: utf-8

"""
    Stock API

    Stock API for Korbyte

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictInt
from pydantic import Field
from korbyte_api_client.models.daily import Daily
from korbyte_api_client.models.pageable_object import PageableObject
from korbyte_api_client.models.sort_object import SortObject
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PageDaily(BaseModel):
    """
    PageDaily
    """ # noqa: E501
    total_pages: Optional[StrictInt] = Field(default=None, alias="totalPages")
    total_elements: Optional[StrictInt] = Field(default=None, alias="totalElements")
    pageable: Optional[PageableObject] = None
    size: Optional[StrictInt] = None
    content: Optional[List[Daily]] = None
    number: Optional[StrictInt] = None
    sort: Optional[SortObject] = None
    number_of_elements: Optional[StrictInt] = Field(default=None, alias="numberOfElements")
    first: Optional[StrictBool] = None
    last: Optional[StrictBool] = None
    empty: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["totalPages", "totalElements", "pageable", "size", "content", "number", "sort", "numberOfElements", "first", "last", "empty"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PageDaily from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of pageable
        if self.pageable:
            _dict['pageable'] = self.pageable.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in content (list)
        _items = []
        if self.content:
            for _item in self.content:
                if _item:
                    _items.append(_item.to_dict())
            _dict['content'] = _items
        # override the default output from pydantic by calling `to_dict()` of sort
        if self.sort:
            _dict['sort'] = self.sort.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PageDaily from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "totalPages": obj.get("totalPages"),
            "totalElements": obj.get("totalElements"),
            "pageable": PageableObject.from_dict(obj.get("pageable")) if obj.get("pageable") is not None else None,
            "size": obj.get("size"),
            "content": [Daily.from_dict(_item) for _item in obj.get("content")] if obj.get("content") is not None else None,
            "number": obj.get("number"),
            "sort": SortObject.from_dict(obj.get("sort")) if obj.get("sort") is not None else None,
            "numberOfElements": obj.get("numberOfElements"),
            "first": obj.get("first"),
            "last": obj.get("last"),
            "empty": obj.get("empty")
        })
        return _obj


