# coding: utf-8

"""
    Stock API

    Stock API for Korbyte

    The version of the OpenAPI document: 0.0.1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictInt, StrictStr
from pydantic import Field
from korbyte_api_client.models.details import Details
from korbyte_api_client.models.exchange import Exchange
from korbyte_api_client.models.tracking import Tracking
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class Ticker(BaseModel):
    """
    Ticker
    """ # noqa: E501
    id: Optional[StrictInt] = None
    symbol: Optional[StrictStr] = None
    name: Optional[StrictStr] = None
    cik: Optional[StrictStr] = None
    composite_figi: Optional[StrictStr] = Field(default=None, alias="compositeFigi")
    share_class_figi: Optional[StrictStr] = Field(default=None, alias="shareClassFigi")
    active: Optional[StrictBool] = None
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    updated_at: Optional[datetime] = Field(default=None, alias="updatedAt")
    exchange: Optional[Exchange] = None
    tracking: Optional[Tracking] = None
    details: Optional[Details] = None
    __properties: ClassVar[List[str]] = ["id", "symbol", "name", "cik", "compositeFigi", "shareClassFigi", "active", "createdAt", "updatedAt", "exchange", "tracking", "details"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of Ticker from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of exchange
        if self.exchange:
            _dict['exchange'] = self.exchange.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tracking
        if self.tracking:
            _dict['tracking'] = self.tracking.to_dict()
        # override the default output from pydantic by calling `to_dict()` of details
        if self.details:
            _dict['details'] = self.details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of Ticker from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "symbol": obj.get("symbol"),
            "name": obj.get("name"),
            "cik": obj.get("cik"),
            "compositeFigi": obj.get("compositeFigi"),
            "shareClassFigi": obj.get("shareClassFigi"),
            "active": obj.get("active"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt"),
            "exchange": Exchange.from_dict(obj.get("exchange")) if obj.get("exchange") is not None else None,
            "tracking": Tracking.from_dict(obj.get("tracking")) if obj.get("tracking") is not None else None,
            "details": Details.from_dict(obj.get("details")) if obj.get("details") is not None else None
        })
        return _obj


